/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-04 10:53
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 1e6 + 5;
const ll INF = 1LL << 60;

vector<int> d(MAXN);
// from reference
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
/* mt19937 gen(1337);                      // seed = 1337; should not return 0 for ra or rb */
const ll ra = gen(), rb = gen();        // shall be two random numbers != 0
ll p = (1LL << 31) - 1;                 // prime > |U| - bigger than universe size
ll carter_wegman(ll a){                 // p = (1LL << 61) - 1 is another Mersenne prime
    return (ra * a + rb) % p;
}
template<>                              // hash function for pair<int,int>
struct std::hash<pair<int,int>> {       // now e.g. unordered_map can be instantiated
    size_t operator()(pair<int,int> a) const {
        ll tmp = (ll)a.first << 32 | (unsigned)a.second;
        return carter_wegman(tmp);      // important to call carter-wegman(tmp) before return
    }
};

struct union_find {
  vector<int> parent, rnk;
  union_find(int N) : parent(N), rnk(N){
    iota(begin(parent), end(parent), 0);
  }
  int find(int v){
    if(v == parent[v]) return v;
    return parent[v] = find(parent[v]);
  }
  bool merge(int a, int b){
    a = find(a), b = find(b);
    if(a == b) return false;
    if(rnk[a] < rnk[b]) swap(a, b);
    parent[b] = a;
    if(rnk[a] == rnk[b]) rnk[a]++;
    return true;
  }
};

void REPLY(int a, int b, int res);
vector<int> edges[MAXN], queries[MAXN];
int anc[MAXN], used[MAXN];
union_find uf(MAXN);
void dfs_tarjan(int v, int de = 1){
  anc[v] = v, used[v] = 1, d[v] = de;
  for(int w : edges[v])
    if(!used[w])
      dfs_tarjan(w, de + 1), uf.merge(v, w),
        anc[uf.find(v)] = v;
  for(int w : queries[v])
    if(used[w]) REPLY(v, w, anc[uf.find(w)]);
}
// from reference 

unordered_map<pii, int> ans;
void REPLY(int a, int b, int lca){
    ans[{a,b}] = ans[{b,a}] = lca;
}
int dist(int a, int b){
    return d[a] + d[b] - 2 * d[ans[{a,b}]];
}


ll H, W;

void addedge(int x, int y){
    edges[x].push_back(y);
    edges[y].push_back(x);
}

void solve(){
    // Code goes here ...
    cin >> H >> W;

    vector<vector<int>> grid(H, vector<int>(W, 0));

    int vid = 0;
    string row, lastrow;
    getline(cin, row);
    getline(cin, row);
    R(i, H){
        lastrow = row;
        getline(cin, row);
        R(j, W){
            int jpos = 2 * j + 1;
            grid[i][j] = vid;

            if(i > 0 and lastrow[jpos] != '_')
                addedge(vid, vid - W);
            if(j > 0 and row[jpos - 1] != '|')
                addedge(vid, vid - 1);

            vid++;
        }
    }


    int M;
    cin >> M;

    vector<int> xs(M), ys(M);
    R(i, M) cin >> xs[i] >> ys[i];

    vector<pii> qs(M-1);
    R(i, M - 1)
        qs[i] = {
            grid[xs[i] - 1][ys[i] - 1],
            grid[xs[i + 1] - 1][ys[i + 1] - 1]
        };


    // usage
    for(auto [a, b] : qs)
        queries[a].push_back(b),
            queries[b].push_back(a);
    dfs_tarjan(0);
    ll res = 0;
    for(auto [a, b] : qs)
        res += dist(a, b);
    // usage

    cout << res << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    solve();

    return 0;
}
        
